_global.Agent = function ( initObj ) {

	for ( var i in initObj ) this[i] = initObj[i];

	this.attachMe();

};

o = Agent.prototype;

o.attachMe = function () {

	this.mc = _root.attachMovie( "agent" , "agent_clip" , 2 , { _x: this.x * 16, _y: this.y * 16 } );

}

o.walkTo = function ( tx , ty ) {

	this.tx = tx;
	this.ty = ty;

	//-- GET NEW DIRECTION
	if ( this.loop !== this.walking ) {

		//-- RESET LAST DIRECTION
		this.dir = 0;
		this.dir = this.getApproximatedDirection();

	}

	this.visitedNodes = [];

	this.loop = this.walking;

}

o.getApproximatedDirection = function () {

	//-- GET LOCAL
	var map = this.map;
	var rx 	= this.x;
	var ry 	= this.y;
	var dir = this.dir;
	var tx = this.tx;
	var ty = this.ty;

	//-- DELTA
	var dx = tx - rx;
	var dy = ty - ry;

	var abs = Math.abs;

	var abs_dx = abs( dx );
	var abs_dy = abs( dy );

	//-- GET MAX DELTA X,Y
	var delta_x = abs_dx >= abs_dy;
	var delta_y = abs_dy >= abs_dx;

	var approximated = [];

	//-- CHECK POSSIBLE DIRECTIONS AND EVALUATE
	var map_ry = map[ ry ];

	if ( ~map_ry[ rx + 1 ] & 1 && dir != 2 ) {

		var pos_dx;

		if ( ( pos_dx = dx >= 0 ) && delta_x ) {

			approximated.push ( { dir: 1, value: 3 } );

		} else if ( pos_dx ) {

			approximated.push ( { dir: 1, value: 2 } );

		} else if ( dir == 1 ) {

			approximated.push ( { dir: 1, value: 1 } );

		} else {

			approximated.push ( { dir: 1, value: 0 } );

		}

	}

	if ( ~map_ry[ rx - 1 ] & 1 && dir != 1 ) {

		var neg_dx;

		if ( ( neg_dx = dx <= 0 ) && delta_x ) {

			approximated.push ( { dir: 2, value: 3 } );

		} else if ( neg_dx ) {

			approximated.push ( { dir: 2, value: 2 } );

		} else if ( dir == 2 ) {

			approximated.push ( { dir: 2, value: 1 } );

		} else {

			approximated.push ( { dir: 2, value: 0 } );

		}

	}

	if ( ~map[ ry + 1 ][ rx ] & 1 && dir != 8 ) {

		var pos_dy;

		if ( ( pos_dy = dy >= 0 ) && delta_y ) {

			approximated.push ( { dir: 4, value: 3 } );

		} else if ( pos_dy ) {

			approximated.push ( { dir: 4, value: 2 } );

		} else if ( dir == 4 ) {

			approximated.push ( { dir: 4, value: 1 } );

		} else {

			approximated.push ( { dir: 4, value: 0 } );

		}

	}

	if ( ~map[ ry - 1 ][ rx ] & 1 && dir != 4 ) {

		var neg_dy;

		if ( ( neg_dy = dy <= 0 ) && delta_y ) {

			approximated.push ( { dir: 8, value: 3 } );

		} else if ( neg_dy ) {

			approximated.push ( { dir: 8, value: 2 } );

		} else if ( dir == 8 ) {

			approximated.push ( { dir: 8, value: 1 } );

		} else {

			approximated.push ( { dir: 8, value: 0 } );

		}

	}

	// SORT FOR BEST RESULT
	approximated.sortOn ( "value" );

	var count = approximated.length;

	//-- CHECK DIAGONAL
	/*var d0 = approximated[ --count ];
	var d1 = approximated[ --count ];

	if ( d0.value == d1.value ) {

		var sum = d0.dir + d1.dir;

		if ( sum ==  5 && ~map[ ry + 1 ][ rx + 1 ] & 1 ) { return  5; };
		if ( sum ==  6 && ~map[ ry + 1 ][ rx - 1 ] & 1 ) { return  6; };
		if ( sum ==  9 && ~map[ ry - 1 ][ rx + 1 ] & 1 ) { return  9; };
		if ( sum == 10 && ~map[ ry - 1 ][ rx - 1 ] & 1 ) { return 10; };

	}*/

	var newDir = approximated.pop().dir;

	if ( newDir == this.visitedNodes[ ry ][ rx ] ) {

		alert += newline + "visited";

		newDir = approximated.pop().dir;

	}

	if ( dir != newDir ) {

		if ( this.visitedNodes[ ry ] == undefined ) this.visitedNodes[ ry ] = [];

		this.visitedNodes[ ry ][ rx ] = newDir;

		alert += newline + "marker " + [ rx,ry ]

	}

	//-- RETURN BEST RESULT
	return newDir;

}

o.walking = function () {

	var dir 	= this.dir;
	var mc 		= this.mc;
	var speed 	= 4;

	if ( dir == 1 ) {

		mc._x += speed;

	} else if ( dir == 2 ) {

		mc._x -= speed;

	} else if ( dir == 4 ) {

		mc._y += speed;

	} else if ( dir == 8 ) {

		mc._y -= speed;

	//-- DIAGONAL
	} else if ( dir == 5 ) {

		mc._x += speed;
		mc._y += speed;

	} else if ( dir == 9 ) {

		mc._x += speed;
		mc._y -= speed;

	} else if ( dir == 10 ) {

		mc._x -= speed;
		mc._y -= speed;

	} else if ( dir == 6 ) {

		mc._x -= speed;
		mc._y += speed;

	}

	if ( mc._x % 16 == 0 && mc._y % 16 == 0 ) {

		     if ( dir == 1 ) this.x += 1
		else if ( dir == 2 ) this.x -= 1
		else if ( dir == 4 ) this.y += 1
		else if ( dir == 8 ) this.y -= 1

		//-- DIAGONAL
		else if ( dir == 5 ) this.x += 1,this.y += 1
		else if ( dir == 9 ) this.x += 1,this.y -= 1
		else if ( dir == 10 ) this.x -= 1,this.y -= 1
		else if ( dir == 6 ) this.x -= 1,this.y += 1

		if ( this.x == this.tx && this.y == this.ty ) {

			trace ( "arrived: " + [ this.tx , this.ty ] );

			delete this.loop;

			this.onArrive();

			return;

		}

		this.dir = this.getApproximatedDirection();

	}

}

